//+------------------------------------------------------------------+
//|                                                          ASI.mq4 |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DarkBlue

//
//
//
//
//

extern string ForSymbol = "";
extern double T         = 300.0;

double ASIBuffer[];
double SIBuffer[];
   
//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0, ASIBuffer); SetIndexEmptyValue(0, 0.0); SetIndexLabel(0, "Accumulation Swing Index");
   SetIndexBuffer(1, SIBuffer);  SetIndexEmptyValue(1, 0.0);

   //
   //
   //
   //
   //
      
   indicatorFileName = WindowExpertName();
   calculateValue    = (ForSymbol=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (ForSymbol=="returnBars");     if (returnBars)     return(0);
                    if (ForSymbol=="") ForSymbol=Symbol();

      IndicatorShortName(ForSymbol+" Accumulation Swing Index ("+DoubleToStr(T,2)+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i, limit, counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ASIBuffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || ForSymbol==Symbol())
   {
      double R, K, TR, ER, SH, Tpoints = T*MarketInfo(Symbol(), MODE_POINT);
      
      //
      //
      //
      //
      //
      
      for(i = limit; i >= 0; i--)
      {
         TR = iATR(Symbol(), 0, 1, i);
         
         if(Close[i+1] >= Low[i] && Close[i+1] <= High[i]) 
            ER = 0; 
         else 
            {
               if(Close[i+1] > High[i]) ER = MathAbs(High[i] - Close[i+1]);
               if(Close[i+1] < Low[i])  ER = MathAbs(Low[i] - Close[i+1]);
            }
         K  = MathMax(MathAbs(High[i] - Close[i+1]), MathAbs(Low[i] - Close[i+1]));
         SH = MathAbs(Close[i+1] - Open[i+1]);
         R  = TR - 0.5*ER + 0.25*SH;
         if (R == 0) 
               SIBuffer[i] = 0; 
         else  SIBuffer[i] = 50*(Close[i] - Close[i+1] + 0.5*(Close[i] - Open[i]) +  0.25*(Close[i+1] - Open[i+1]))*(K / Tpoints) / R;
         ASIBuffer[i] = ASIBuffer[i+1] + SIBuffer[i];
      }
      return(0);
   }

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,0,indicatorFileName,"returnBars",0,0)));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(ForSymbol,0,Time[i]);
            ASIBuffer[i] = iCustom(ForSymbol,0,indicatorFileName,"calculateValue",T,0,y);
   }
   return(0);
}

